/*
 * Manually build for Borland C++ 5.0
 * thn@stacken.kth.se, 2000-07-26 20:31:36	 
 */	 

/* This is (as usual) a generated file,
   it is also machine dependent */

#ifndef __ROKEN_H__
#define __ROKEN_H__

/* -*- C -*- */
/*
 * Copyright (c) 1995, 1996, 1997, 1998, 1999 Kungliga Tekniska Hgskolan
 * (Royal Institute of Technology, Stockholm, Sweden).
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * 3. Neither the name of the Institute nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* $Id: roken.h,v 1.8 1999/12/02 16:58:36 joda Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <errno.h>

#include <winsock.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ROKEN_LIB_FUNCTION
#if defined(__BORLANDC__)
#define ROKEN_LIB_FUNCTION _stdcall
#elif defined(_MSC_VER)
#define ROKEN_LIB_FUNCTION /* not-ready-definition-yet2 */
#else
#define ROKEN_LIB_FUNCTION
#endif
#endif

#include <roken-common.h>

int ROKEN_LIB_FUNCTION snprintf (char *str, size_t sz, const char *format, ...)
     __attribute__ ((format (printf, 3, 4)));

int ROKEN_LIB_FUNCTION vsnprintf (char *str, size_t sz, const char *format, va_list ap)
     __attribute__((format (printf, 3, 0)));

int ROKEN_LIB_FUNCTION asprintf (char **ret, const char *format, ...)
     __attribute__ ((format (printf, 2, 3)));

int ROKEN_LIB_FUNCTION vasprintf (char **ret, const char *format, va_list ap)
     __attribute__((format (printf, 2, 0)));

int ROKEN_LIB_FUNCTION asnprintf (char **ret, size_t max_sz, const char *format, ...)
     __attribute__ ((format (printf, 3, 4)));

int ROKEN_LIB_FUNCTION vasnprintf (char **ret, size_t max_sz, const char *format, va_list ap)
     __attribute__((format (printf, 3, 0)));

#ifdef NEED_STRTOK_R_PROTO
char *ROKEN_LIB_FUNCTION strtok_r(char *s1, const char *s2, char **lasts);
#endif

int ROKEN_LIB_FUNCTION gettimeofday (struct timeval *tp, void *ignore);

int ROKEN_LIB_FUNCTION strcasecmp(const char *s1, const char *s2);

int ROKEN_LIB_FUNCTION strncasecmp(const char *s1, const char *s2, size_t n);

int ROKEN_LIB_FUNCTION getuid(void);

size_t ROKEN_LIB_FUNCTION strlcpy (char *dst, const char *src, size_t dst_sz);

size_t ROKEN_LIB_FUNCTION strlcat (char *dst, const char *src, size_t dst_sz);

size_t ROKEN_LIB_FUNCTION strnlen (const char *s, size_t len);

int ROKEN_LIB_FUNCTION flock(int fd, int operation);

int ROKEN_LIB_FUNCTION roken_concat (char *s, size_t len, ...);

size_t ROKEN_LIB_FUNCTION roken_mconcat (char **s, size_t max_len, ...);

int ROKEN_LIB_FUNCTION roken_vconcat (char *s, size_t len, va_list args);

size_t ROKEN_LIB_FUNCTION roken_vmconcat (char **s, size_t max_len, va_list args);

ssize_t ROKEN_LIB_FUNCTION net_write (int fd, const void *buf, size_t nbytes);
#define krb_net_write net_write

ssize_t ROKEN_LIB_FUNCTION net_read (int fd, void *buf, size_t nbytes);
#define krb_net_read net_read

#ifdef WIN32
struct addrinfo {
     struct addrinfo *ai_next;	
     int    ai_flags;
     int    ai_family;
     int    ai_socktype;
     int    ai_protocol;
     char * ai_canonname;
     size_t ai_addrlen;
     void * ai_addr;
};

#define EWOULDBLOCK             WSAEWOULDBLOCK
#define EINPROGRESS             WSAEINPROGRESS
#define EALREADY                WSAEALREADY
#define ENOTSOCK                WSAENOTSOCK
#define EDESTADDRREQ            WSAEDESTADDRREQ
#define EMSGSIZE                WSAEMSGSIZE
#define EPROTOTYPE              WSAEPROTOTYPE
#define ENOPROTOOPT             WSAENOPROTOOPT
#define EPROTONOSUPPORT         WSAEPROTONOSUPPORT
#define ESOCKTNOSUPPORT         WSAESOCKTNOSUPPORT
#define EOPNOTSUPP              WSAEOPNOTSUPP
#define EPFNOSUPPORT            WSAEPFNOSUPPORT
#define EAFNOSUPPORT            WSAEAFNOSUPPORT
#define EADDRINUSE              WSAEADDRINUSE
#define EADDRNOTAVAIL           WSAEADDRNOTAVAIL
#define ENETDOWN                WSAENETDOWN
#define ENETUNREACH             WSAENETUNREACH
#define ENETRESET               WSAENETRESET
#define ECONNABORTED            WSAECONNABORTED
#define ECONNRESET              WSAECONNRESET
#define ENOBUFS                 WSAENOBUFS
#define EISCONN                 WSAEISCONN
#define ENOTCONN                WSAENOTCONN
#define ESHUTDOWN               WSAESHUTDOWN
#define ETOOMANYREFS            WSAETOOMANYREFS
#define ETIMEDOUT               WSAETIMEDOUT
#define ECONNREFUSED            WSAECONNREFUSED
#define ELOOP                   WSAELOOP
//#define ENAMETOOLONG            WSAENAMETOOLONG
#define EHOSTDOWN               WSAEHOSTDOWN
#define EHOSTUNREACH            WSAEHOSTUNREACH
#define ENOTEMPTY               WSAENOTEMPTY
#define EPROCLIM                WSAEPROCLIM
#define EUSERS                  WSAEUSERS
#define EDQUOT                  WSAEDQUOT
#define ESTALE                  WSAESTALE
#define EREMOTE                 WSAEREMOTE

struct iovec {
	void *	iov_base;
	size_t	iov_len;
};

struct msghdr {
	void *	msg_name;
	size_t	msg_namelen;
	void * 	msg_iov;
	size_t	msg_iovlen;
};

#endif

int ROKEN_LIB_FUNCTION getaddrinfo(const char *nodename,
	    const char *servname,
	    const struct addrinfo *hints,
	    struct addrinfo **res);

int ROKEN_LIB_FUNCTION inet_pton(int af, const char *src, void *dst);

int ROKEN_LIB_FUNCTION inet_aton(const char *cp, struct in_addr *addr);

struct hostent * ROKEN_LIB_FUNCTION getipnodebyname (const char *name,
	int af, int flags, int *error_num);

struct hostent * ROKEN_LIB_FUNCTION getipnodebyaddr (const void *src,
	size_t len, int af, int *error_num);

void ROKEN_LIB_FUNCTION freehostent (struct hostent *h);

void ROKEN_LIB_FUNCTION freeaddrinfo(struct addrinfo *ai);

struct hostent * ROKEN_LIB_FUNCTION copyhostent (const struct hostent *h);

#define fsync(x)

int ROKEN_LIB_FUNCTION mkstemp(char *xtemplate);

int ROKEN_LIB_FUNCTION roken_gethostby_setup(const char *proxy_spec,
	const char *dns_spec);

struct hostent* ROKEN_LIB_FUNCTION roken_gethostbyname(const char *hostname);

struct hostent* ROKEN_LIB_FUNCTION roken_gethostbyaddr(const void *addr,
	size_t len, int type);


const char * ROKEN_LIB_FUNCTION get_default_username (void);

int ROKEN_LIB_FUNCTION roken_getaddrinfo_hostspec(const char *hostspec, 
			   int port,
			   struct addrinfo **ai);

int ROKEN_LIB_FUNCTION roken_getaddrinfo_hostspec2(const char *hostspec, 
			   int socktype,
			   int port,
			   struct addrinfo **ai);

ssize_t ROKEN_LIB_FUNCTION sendmsg(int s, const struct msghdr *msg, int flags);
#ifdef GETSERVBYNAME_PROTO_COMPATIBLE
 #define roken_getservbyname(x,y) getservbyname(x,y)
#else
 #define roken_getservbyname(x,y) getservbyname((char *)x, (char *)y)
#endif

#ifdef WIN32
time_t ROKEN_LIB_FUNCTION time_r(time_t *tloc);
#define sockaddr_storage sockaddr

void ROKEN_LIB_FUNCTION warnx(const char *fmt, ...);
void ROKEN_LIB_FUNCTION errx(int exitcode, char *fmt, ...);

#else
#define time_r time
#endif
#ifdef __cplusplus
}
#endif

#endif /* __ROKEN_H__ */
